/*
 *
 *  Heavily adopted from the HMMER code
 * 
 */

#include "rand.h"
#include <math.h>
#include <stdio.h>
#include <limits.h>

#ifdef HUGE_VAL
#define SCALEINFTY HUGE_VAL	 
#endif

#define LOGSUM_SIZE 16000
#define SCALE 1000.0f

#define sreLOG2(x)  ((x) > 0 ? log(x) * 1.44269504f : -9999)
#define sreEXP2(x)  (exp((x) * 0.69314718f )) 

#define HMMER3_MIN(a,b)          (((a)<(b))?(a):(b))
#define HMMER3_MAX(a,b)          (((a)>(b))?(a):(b))

#define LARGESCALE  10000

#define round(x) ((x) < INT_MIN-0.5 || (x) > INT_MAX+0.5 ?\
error() : ((x)>=0?(int)((x)+0.5):(int)((x)-0.5))

void init_logsum(void);
float logsum(float a,float b);
float logsum_print(float a,float b);
float prob2scaledprob(float p);
float scaledprob2prob(float p);
